
IMPLEMENTATION MODULE Cadenas;
FROM IO IMPORT WrLn, RdLn, WrStr, RdChar, WrChar, RdStr, WrChar;

PROCEDURE Stop;
VAR car:CHAR;
BEGIN
  REPEAT
    WrLn;
    RdLn;
    WrStr(" Pulse ENTER...");
    car:=RdChar();
  UNTIL car=CHR(13);
END Stop;

(* Procedimiento que de vuelve la longitud de la cadena de caracteres *)
PROCEDURE Longitud(c1:ARRAY OF CHAR):CARDINAL;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(c1)) AND (c1[i]<>CHR(0)) DO
     i:=i+1;
  END;
  RETURN i;
END Longitud;

(* Procedimiento que compara dos cadenas de caracteres *)
PROCEDURE Comparar(c1,c2:ARRAY OF CHAR):INTEGER;
VAR i,n1,n2:CARDINAL;
BEGIN
 i:=0;
 n1:=Longitud(c1);
 n2:=Longitud(c2);
 WHILE (i<n1) AND (i<n2) AND (CAP(c1[i])=CAP(c2[i])) DO
     i:=i+1;
 END;
 IF (n1=n2) AND (i=n1) THEN
    RETURN 0;
 ELSIF ((n1<n2) AND (i=n1)) OR ((n1<>i) AND (CAP(c1[i])<CAP(c2[i]))) THEN
    RETURN -1;
 ELSIF ((n2<n1) AND (i=n2)) OR ((n2<>i) AND (CAP(c2[i])<CAP(c1[i]))) THEN
    RETURN 1;
 END;
END Comparar;


(* Procedimiento que asigna una cadena a otra *)
PROCEDURE Asignar(VAR c1:ARRAY OF CHAR;c2:ARRAY OF CHAR);
VAR i,n1,n2:CARDINAL;
BEGIN
 i:=0;
 n1:=Longitud(c1);
 n2:=Longitud(c2);
 WHILE (i<=HIGH(c1)) AND (i<=HIGH(c2)) AND (i<=n2) DO
    c1[i]:=c2[i];
    i:=i+1;
 END;
 IF (i<=HIGH(c1)) AND (c1[i]<>CHR(0)) THEN
    c1[i]:=CHR(0);
 END;
END Asignar;

END Cadenas.