

(*LabII Practica tipo examen*)

MODULE Menu;
FROM IO IMPORT WrStr, RdStr, WrLn, RdLn, RdChar, WrChar, RdCard, WrCard;
FROM Cadenas IMPORT Stop, Longitud, Comparar, Asignar;
FROM Gimnasio IMPORT TipoGim, CrearGimnasio, AnadirSocio, BorrarSocio,
                     ModificarSocio, VisualizarGimnasio, VolcarSocios, Fichero_A_TAD,
                     DestruirGimnasio;
FROM Window IMPORT Clear;

VAR
  nombre,telef,cuota,act1,act2:ARRAY [0..19] OF CHAR;
  Gim:TipoGim;
  salir, ExisteFich:BOOLEAN;

  (***** variables booleanas de error *****)
  NoCreado:BOOLEAN;       (* v1 *)
  NoMem:BOOLEAN;          (* v2 *)
  NoSocio:BOOLEAN;        (* v3 *)
  NoActividad:BOOLEAN;    (* v4 *)
  (**************)

  opcion:CHAR;


(***********************************************************)
(***********************************************************)

PROCEDURE PMenu;
BEGIN
WrStr("      MENU        "); WrLn;
WrStr("-----------------------------"); WrLn;
WrStr(" A.- Aadir socio. "); WrLn;
WrStr(" B.- Borrar socio. "); WrLn;
WrStr(" C.- Modificar socio. "); WrLn;
WrStr(" D.- Visualizar.  "); WrLn;
WrStr(" E.- Volcar a fichero GIMNASIO.DAT. "); WrLn;
WrStr(" F.- Volcar fichero GIMNASIO.DAT a TAD. "); WrLn;
WrStr(" G.- Fin.   "); WrLn;
END PMenu;


(***************************************************)
PROCEDURE Control(VAR opcion:CHAR;VAR salir:BOOLEAN);
TYPE Conj=SET OF CHAR;
VAR si:CHAR;
BEGIN
   WrStr(" OPCION?  "); RdLn; opcion:=CAP(RdChar());
   IF NOT(opcion IN Conj{"A","B","C","D","E","F","G"}) THEN
      WrStr(" OPCION INCORRECTA ");
      Stop;
   ELSIF opcion="G" THEN
     WrStr(" Seguro? (S/N) "); RdLn; si:=CAP(RdChar());
     IF si="S" THEN
        salir:=TRUE;
     END;
   END;
END Control;


(***************************************************)
(* Procedimiento que imprime los errores presentes *)
PROCEDURE Errores(NoCreado,NoMem,NoSocio,NoActividad:BOOLEAN);
BEGIN
    IF NoCreado THEN
          WrLn;
          WrStr(" NO SE HA INICIADO CORRECTAMENTE LA VARIABLE GLOBAL GIM (FALTA MEMORIA).");
    END;
    IF NoMem THEN
          WrLn;
          WrStr(" NO SE PUDO INTRODUCIR POR FALTA DE MEMORIA.");
    END;
    IF NoSocio THEN
          WrLn;
          WrStr(" NO EXISTE EL SOCIO.");
    END;
    IF NoActividad THEN
          WrLn;
          WrStr(" ALGUNA/S ACTIVIDAD NO EXISTE.");
    END;
END Errores;


(******************************************************)
(******************************************************)
(***********    PRINCIPAL   ***************************)

BEGIN

  salir:=FALSE;
  ExisteFich:=TRUE;

  CrearGimnasio(NoCreado,Gim);

IF NOT(NoCreado) THEN        (*****************************)
  REPEAT

    NoCreado:=FALSE;     (* Variable global Gim no creada por falta de memoria *)
    NoMem:=FALSE;        (* No se pudo introducir por falta de memoria *)
    NoSocio:=FALSE;      (* No existe el nombre del socio *)
    NoActividad:=FALSE;  (* No existe dicha actividad *)

    Asignar(act1,"");    (* Inicializar con cadena vacia *)
    Asignar(act2,"");

    Clear;
    PMenu;
    Control(opcion,salir);
   CASE opcion OF

     (********************************************************)
   | "A":    Clear;
             WrStr(" Escriba el nombre del socio: "); RdStr(nombre);
             WrStr(" Escriba telefono: "); RdStr(telef);
             WrStr(" Escriba la cuota: "); RdStr(cuota);
             IF Comparar(cuota,"3500")=0 THEN
                WrStr(" Introduzca la actividad: "); RdStr(act1);
                IF Comparar(act1,"TODAS")<>0 THEN
                  AnadirSocio(Gim,nombre,telef,cuota,act1,act2,NoMem,NoActividad,NoCreado);
                ELSE  WrLn; WrStr(" TODAS NO PUEDE SER. "); END;
             ELSIF Comparar(cuota,"4500")=0 THEN
                WrStr(" Introduzca la actividad 1: "); RdStr(act1);
                WrStr(" Introduzca la actividad 2: "); RdStr(act2);
                IF (Comparar(act1,"TODAS")<>0) OR (Comparar(act2,"TODAS")<>0) THEN
                  AnadirSocio(Gim,nombre,telef,cuota,act1,act2,NoMem,NoActividad,NoCreado);
                ELSE WrLn; WrStr(" TODAS NO PUEDE SER. "); END;
             ELSIF Comparar(cuota,"5500")=0 THEN
                Asignar(act1,"TODAS");
                AnadirSocio(Gim,nombre,telef,cuota,act1,act2,NoMem,NoActividad,NoCreado);
             ELSE
                WrLn;
                WrStr(" CUOTA NO DEFINIDA. "); WrLn;
             END;

     (**************************************************************)
   | "B":    Clear;
             WrStr(" Escriba el nombre del socio: "); RdStr(nombre);
             BorrarSocio(Gim,nombre,NoSocio,NoCreado);

     (**************************************************************)
   | "C":    Clear;
             WrStr(" Escriba el nombre del socio: "); RdStr(nombre);
             WrStr(" Escriba la nueva cuota: "); RdStr(cuota);
             IF Comparar(cuota,"3500")=0 THEN
                WrStr(" Introduzca la actividad: "); RdStr(act1);
                act2:="";
                IF (Comparar(act1,"TODAS")<>0) THEN
                  ModificarSocio(Gim,nombre,cuota,act1,act2,NoSocio,NoMem,NoActividad,NoCreado);
                ELSE WrLn; WrStr(" TODAS NO PUEDE SER. "); END;
             ELSIF Comparar(cuota,"4500")=0 THEN
                WrStr(" Introduzca la actividad 1: "); RdStr(act1);
                WrStr(" Introduzca la actividad 2: "); RdStr(act2);
                IF (Comparar(act1,"TODAS")<>0) OR (Comparar(act2,"TODAS")<>0) THEN
                  ModificarSocio(Gim,nombre,cuota,act1,act2,NoSocio,NoMem,NoActividad,NoCreado);
                ELSE WrLn; WrStr(" TODAS NO PUEDE SER. "); END;
             ELSIF Comparar(cuota,"5500")=0 THEN
                Asignar(act1,"TODAS");
                act2:="";
                ModificarSocio(Gim,nombre,cuota,act1,act2,NoSocio,NoMem,NoActividad,NoCreado);
             ELSE
                WrLn;
                WrStr(" CUOTA NO DEFINIDA "); WrLn;
             END;

     (*********************************************************)
   | "D":    Clear;
             VisualizarGimnasio(Gim,NoCreado);

     (*********************************************************)
   | "E":    Clear;
             WrStr(" Volcado de la estructura al fichero GIMNASIO.DAT: ");
             Stop;
             VolcarSocios(Gim,NoCreado);
             WrStr(" Ya est. ");

     (*********************************************************)
   | "F":    Clear;
             WrStr(" Los datos del fichero GIMNASIO.DAT se volcaran a la estructura: ");
             Stop;
             Fichero_A_TAD(Gim,"GIMNASIO.DAT",ExisteFich,NoCreado,NoMem);
             IF ExisteFich THEN
                 WrStr(" Ya est. ");
             ELSE
                 WrLn;
                 WrStr(" NO EXISTE EL FICHERO GIMNASIO.DAT. ");
             END;
   END;                                     (* FIN CASE *)

    (*************************)             (* LISTADO DE ERRORES *)
    Errores(NoCreado,NoMem,NoSocio,NoActividad);
    (*************************)

    Stop;
  UNTIL salir;                              (* FIN REPEAT *)
 ELSE
   Errores(NoCreado,NoMem,NoSocio,NoActividad);
 END;                                       (* IF NoCreado THEN *)
  DestruirGimnasio(Gim);
  WrLn;
  WrLn;
  WrLn;
  WrStr(" Hasta Luego, Lucas......Salu2. Suerte en el examen ");
END Menu.









